//
//  pie.cpp
//  A Pie Chart Application with Resources
//  Copyright (c) William H. Murray and Chris H. Pappas, 2001
//

#include "stdafx.h"
#include "pie.h"
#include <math.h>

#define MAX_LOADSTRING 100
#define radius         180
#define maxnumwedge    10
#define pi             3.14159265359

// Global Variables:
HINSTANCE hInst;					  // current instance
TCHAR szTitle[MAX_LOADSTRING];		  // The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];  // The title bar text

ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK    PieDlgProc(HWND, UINT, WPARAM, LPARAM);

char szTString[80] = "(pie chart title area)";
unsigned int iWedgesize[maxnumwedge] = {5, 20, 10, 15};
long lColor[maxnumwedge] = {0x0L, 0xFFL, 0xFF00L, 0xFFFFL,
                            0xFF0000L, 0xFF00FFL,
                            0xFFFF00L, 0xFFFFFFL,
                            0x8080L, 0x808080L};

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle,
               MAX_LOADSTRING);
	LoadString(hInstance, IDC_PIE,
               szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance,
                                  (LPCTSTR)IDC_PIE);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd,
                                  hAccelTable,
                                  &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}

ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance,
                                  (LPCTSTR)IDI_PIE);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_PIE;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance,
                                  (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle

   hWnd = CreateWindow(szWindowClass, szTitle,
                       WS_OVERLAPPEDWINDOW,
                       CW_USEDEFAULT, 0,
                       CW_USEDEFAULT, 0,
                       NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message,
                         WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

    HBRUSH hBrush;
    static int xClientView, yClientView;

    unsigned int iTotalWedge[maxnumwedge+1];
    int i, iNWedges;

    iNWedges = 0;
    for (i = 0; i < maxnumwedge; i++) {
        if(iWedgesize[i] != 0) iNWedges++;
    }

    iTotalWedge[0] = 0;

    for (i=0 ; i < iNWedges; i++)
        iTotalWedge[i+1] = iTotalWedge[i] + iWedgesize[i];

	switch (message) 
	{
    case WM_SIZE:
        xClientView = LOWORD(lParam);
        yClientView = HIWORD(lParam);
        break;
 	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX,
				      hWnd, (DLGPROC)About);
			break;
        case IDM_INPUT:
            DialogBox(hInst, (LPCTSTR) IDD_DIALOG1,
                      hWnd, (DLGPROC)PieDlgProc);
            InvalidateRect(hWnd, NULL, TRUE);
            UpdateWindow(hWnd);
            break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message,
                                 wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);

        SetMapMode(hdc, MM_ISOTROPIC);
        SetWindowExtEx(hdc, 500, 500, NULL);
        SetViewportExtEx(hdc, xClientView,
                         -yClientView, NULL);
        SetViewportOrgEx(hdc, xClientView / 2,
                         yClientView / 2, NULL);

        if (xClientView > 200)
            TextOut(hdc, strlen(szTString) * (-8 / 2),
                    240, szTString,strlen(szTString));

        for(i = 0; i < iNWedges; i++) {
            hBrush = CreateSolidBrush(lColor[i]);
            SelectObject(hdc, hBrush);
            Pie(hdc, -200, 200, 200, -200,
                (int)(radius * cos(2 * pi * iTotalWedge[i] /
                iTotalWedge[iNWedges])),
                (int)(radius * sin(2 * pi * iTotalWedge[i] /
                iTotalWedge[iNWedges])),
                (int)(radius * cos(2 * pi * iTotalWedge[i+1] /
                iTotalWedge[iNWedges])),
                (int)(radius * sin(2 * pi * iTotalWedge[i+1] /
                iTotalWedge[iNWedges])));
        }

        ValidateRect(hWnd,NULL);
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message,
					   WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK ||
            LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}

// Message handler for data entry dialog box.
LRESULT CALLBACK PieDlgProc(HWND hDlg, UINT message,
                            WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
    case WM_INITDIALOG:
        return FALSE;

    case WM_COMMAND:
        switch (wParam)
        {
            case IDOK:
                GetDlgItemText(hDlg, IDC_TEXT1,
                               szTString, 80);
                iWedgesize[0] = GetDlgItemInt(hDlg, IDC_DATA1,
                                              NULL, 0);
                iWedgesize[1] = GetDlgItemInt(hDlg, IDC_DATA2,
                                              NULL, 0);
                iWedgesize[2] = GetDlgItemInt(hDlg, IDC_DATA3,
                                              NULL, 0);
                iWedgesize[3] = GetDlgItemInt(hDlg, IDC_DATA4,
                                              NULL, 0);
                iWedgesize[4] = GetDlgItemInt(hDlg, IDC_DATA5,
                                              NULL, 0);
                iWedgesize[5] = GetDlgItemInt(hDlg, IDC_DATA6,
                                              NULL, 0);
                iWedgesize[6] = GetDlgItemInt(hDlg, IDC_DATA7,
                                              NULL, 0);
                iWedgesize[7] = GetDlgItemInt(hDlg, IDC_DATA8,
                                              NULL, 0);
                iWedgesize[8] = GetDlgItemInt(hDlg, IDC_DATA9,
                                              NULL, 0);
                iWedgesize[9] = GetDlgItemInt(hDlg, IDC_DATA10,
                                              NULL, 0);
                EndDialog(hDlg, TRUE);
                break;
            case IDCANCEL:
                EndDialog(hDlg, FALSE);
                break;
            default:
                return FALSE;
        }
        break;
    default:
        return FALSE;
    }
    return TRUE;
}

